%BY Ph MSC Csar Manuel Dez Chirinos
%function NanoWeibull(b)
% Create a figure showing the weibull PDF axes and checkboxes
% Load some tabular data like this: stati.txt
%Example of nano Weibull
%load your data like this and use this two sintaxis: 
%       b = 'stati.txt';
%       NanoWeibull(b)
function NanoWeibull(b)
a=load(b);
v = a(:,2);
v = v(~isnan(v));
w1=sort(v);
[r,c,y] = find(w1>0); 
w2=w1(r);
w=log(w2);
vst1=min(w2);
vst2=max(w2);
lthaevs = length(w);
rm = (r-0.3)./(lthaevs+0.4);
lnrm = log(log((1)./(1-rm)));

brobaevel = robustfit(w,lnrm);

v1 = floor(vst1);
v2 = round(vst2);
vax1=min(v);
vax2=max(v);
vaxi1 = floor(vax1);
vaxi2 = round(vax2);

v4=(v2-v1)*0.25;
v6=(v1+v2)/2;
v5=round(v6);
v3=round(v4);
ax1=vaxi1;
ax2=vaxi2;
ax3=(abs(ax1)+abs(ax2))*.5;
if (vst1 >= 0) 
   GAMMA = 0;
else
   GAMMA = vst1;
end;

%GAMMA = 0;
BETA1 = brobaevel(2,:);BETA=real(BETA1);
THETA1 = exp(-(brobaevel(1,:)/BETA));THETA=real(THETA1);
OMEGA = BETA./THETA;
TAO = (w2-GAMMA)/THETA;
EQ4=(TAO).^(BETA);
EQ1=OMEGA;
EQ2=(TAO).^(BETA-1);
EQ3=exp(-EQ4);
we=EQ1.*EQ2.*EQ3;
wax2=max(we);
if (wax2 < 0.1) 
   waxi2 = 0.1;
    else if ((wax2 < 0.25) &&(wax2>0.1))
   waxi2 = 0.25;
        else if ((wax2 < 0.5) &&(wax2>0.25))
   waxi2 = 0.5;
        else 
   waxi2 =1;
            end
        end
end;

%wax2=max(we);
%waxi2 = round(wax2);

%Histogram%
intervalWidth = 1;
x = ax1:intervalWidth:ax2;
ncount1 = histc(w2,x);
relativefreq = ncount1/length(w);
figure(1);
bar(x+intervalWidth/2, relativefreq,1,'FaceColor',[1 0 0],'BarWidth',1);
xlim([ax1 ax2])
axis([ax1 ax2 0 waxi2])
set(gca,'YTick',0:waxi2/2:waxi2,'FontSize',18)
set(gca,'XTick',ax1:ax3:ax2,'FontSize',18)
xlabel('Data (m/s)','FontSize',22)
ylabel('Frequencies (%)','FontSize',22)
title('WEIBULL DISTRIBUTION','FontSize',28)

hold on
plot(w2,we,'.','LineWidth',2,...
'MarkerEdgeColor','k',...
'MarkerFaceColor','g',...
'MarkerSize',5)
hold off
